!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: bomnew.gs 25988 2011-06-14 17:55:54Z stever $
!
! Description - Create reserved objects from Smalltalk, that are 
!   newly created in gemstone64. These are objects that may be created
!   directly in the target repository, if in repository conversion.
! 
! Repository conversion uses this file.
!
!=========================================================================


! install the method required for kernel class creation of classes with
! reserved OOPs
!
category: 'Repository Conversion'
method: Object
_unsafeSet11Oop: aPositiveInteger

  "aPositiveInteger must be the integer value of a gs64v1.1 OopType" 

  <primitive: 385>
  ^ self _primitiveFailed: #_unsafeSet11Oop:
%

category: 'Repository Conversion'
method: Object
_unsafeSetOop: aPositiveInteger

  "aPositiveInteger must be the integer value of a gs64v2.x OopType" 

  <primitive: 535>
  ^ self _primitiveFailed: #_unsafeSetOop:
%

! fix 32731, _objectForOop now in image

!  fix 31162 , added new privilege #CodeModification and
!     removed rename obsolete privleges as #Obsolete<priv>
run
UserProfile _classVars
    at: #PrivilegeNames
	put:
           #(#SystemControl #ObsoleteStatistics #SessionAccess #UserPassword
	     #DefaultObjectSecurityPolicy #FedAdminPrivilege #OtherPassword
	     #ObjectSecurityPolicyCreation #ObjectSecurityPolicyProtection #FileControl
	     #GarbageCollection #CodeModification
             #NoPerformOnServer #NoUserAction 
	     #NoGsFileOnServer #NoGsFileOnClient 
             #SessionPriority ) ;
    at: #InversePrivileges put:
	#( NoPerformOnServer NoUserAction NoGsFileOnServer NoGsFileOnClient ).
^ true
%

! Gs64 v3.0 remove Associations of some private classes from Globals
run
Globals
  removeKey: #Large8ByteLeaf ifAbsent:[] ;
  removeKey: #Large4ByteLeaf ifAbsent:[] ;
  removeKey: #Large2ByteLeaf ifAbsent:[] .
^ true
%
