!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: ieucstring.gs 25988 2011-06-14 17:55:54Z stever $
!
! Superclass Hierarchy:
!   InvariantEUCString, EUCString, JapaneseString, CharacterCollection,
!   SequenceableCollection, Collection, Object.
!
!=========================================================================

removeallmethods InvariantEUCString
removeallclassmethods InvariantEUCString

category: 'For Documentation Installation only'
classmethod: InvariantEUCString
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'This class represents an invariant Japanese string in Extended Unix Code
 format.'.
doc documentClassWith: txt.

self description: doc.
%

category: 'Formatting'
method: InvariantEUCString
asEUCString

"Returns an EUCString representing the receiver."

^ EUCString withBytes: self
%

