category: '*gsmonticello'
method: Class
classComment: comment stamp: aString
| doc txt |
doc := GsClassDocumentation newForClass: self.
txt := (GsDocText new) details: comment.
doc documentClassWith: txt.
self description: doc.
aString == nil
        ifTrue: [ self commentStamp: self class changeStamp ]
        ifFalse: [ self commentStamp: aString ].
%

category: '*gsmonticello'
method: Class
classSide
	^self theMetaClass
%

category: '*gsmonticello'
method: Class
poolDictionariesForNames: poolDictionaryNames

        | ar existingDict |
        ar := Array new.
        poolDictionaryNames do: [:poolName |
                existingDict := GsSession currentSession userProfile symbolList objectNamed: poolName.
                (existingDict isKindOf: SymbolDictionary)
                        ifTrue: [ ar add: existingDict ].
                ((existingDict isKindOf: Class) and: [existingDict isSubclassOf: SharedPool])
                        ifTrue: [
                                ar add: existingDict _createClassVarsDict.
                                existingDict _classVars name: poolName asSymbol.
                        ].
                existingDict == nil
                        ifTrue: [ | pool |
                                pool := SymbolDictionary new.
                                pool name: poolName asSymbol.
                                ar add: pool.
                        ].
        ].
^ar
%

category: '*gsmonticello'
method: Class
classComment

        | desc comment |
        (desc := self _description) ifNil:[ ^ '' ].
        (comment := desc detailsAboutClass) ifNil: [ ^'' ].
        ^comment
%

category: '*gsmonticello'
method: Class
_description

"Returns the description of this class.

 TODO, for upgrade of a Gs64 v2.3 repository, need to install
 this method as returning value of transientMethDicts instVar. "

| exd |
(exd := extraDict) ifNil:[ ^ nil ].
^ exd at:#description otherwise: nil
%

category: '*gsmonticello'
method: Class
_sortedClassVarNames
	"Returns a sorted list of class variable names. "

	^ SortedCollection withAll: self classVarNames
%

category: '*gsmonticello'
method: Class
poolDictionaryNames
| ar anArray |
ar := Array new.
self sharedPools do: [:each |
  anArray := System myUserProfile dictionaryAndSymbolOf: each.
  anArray == nil
        ifTrue: [ | d |
            (d := System myUserProfile objectNamed: each name) ~~ nil 
			ifTrue: [ 
				((d isKindOf: Class) and: [d isSubclassOf: (GsSession currentSession userProfile symbolList objectNamed: #SharedPool)])
					ifTrue: [ ar add: each name  ]
					ifFalse: [ ar add: ' "(not named)" ' ]
			]
			ifFalse: [ar add: ' "(not named)" ' ]
        ]
        ifFalse: [ ar add: (anArray at: 2)].
].
^ar
%

category: '*gsmonticello'
method: Class
_mcDefinitionType
  | type opts superC |
  superC := self superClass .
  (self isBytes and:[ superC isBytes not ]) ifTrue:[ 
    type := #bytes
  ] ifFalse:[
    (self isIndexable and:[ superC isIndexable not]) ifTrue:[
      type := #variable 
    ] ifFalse:[
      type := #normal  
  ]].
  opts := self _nonInheritedOptions .
  ^ opts size > 0 ifTrue:[ { type . opts } ] ifFalse:[ type ] . 
%

