!=========================================================================
! Copyright (C) VMware, Inc. 2008-2011.  All Rights Reserved.
!
! $Id: Symbol_ruby.gs 25988 2011-06-14 17:55:54Z stever $
!
!   
!=========================================================================

!  additional methods  for Symbol to support Ruby 

category: 'Ruby support'
classmethod: Symbol
_rubyAllSymbols
  
| allSyms |
allSyms := ((AllUsers userWithId:'SymbolUser') resolveSymbol: #AllSymbols) value.
^ Array withAll: allSyms keys .
%

method: Symbol
describeClassName

self size == 0 ifTrue:[ ^ String withAll:'a(unnamed)' ].
^ super describeClassName 
%

method: Symbol
_rubyBasicDup

  ^ self
%

! fix Trac 806
method: Symbol
_unscheduleProcess: aGsProcess

  ^ self "do nothing, receiver usually #IoSelect"
%
! fix Trac 806
method: Symbol
_changePriority: aGsProcess from: oldPriority

  ^ self "do nothing, receiver usually #IoSelect"
%

!=========================================================================
method: DoubleByteSymbol
_rubyBasicDup

  ^ self
%

!=========================================================================

method: DoubleByteString
_asSymbolWithRubySuffix: argInt

"no primitive support yet for DoubleByteSymbols"

| numColons str |
str := DoubleByteString withAll: self .
numColons := (argInt bitAnd: 16rC) bitShift: -2 .
numColons timesRepeat:[ str add:  $: ] .
(argInt bitAnd: 16r2) ~~ 0 ifTrue:[ str add:  $* ].
(argInt bitAnd: 16r1) ~~ 0 ifTrue:[ str add:  $& ].
^ str asSymbol   "TODO tag the symbol with prefix"
%

