!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: selectblock.gs 25988 2011-06-14 17:55:54Z stever $
!
! Superclass Hierarchy:
!   SelectBlock, BlockClosure, Object.
!
!=========================================================================

removeallmethods SelectBlock
removeallclassmethods SelectBlock

category: 'For Documentation Installation only'
classmethod: SelectBlock
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'SelectBlock is a concrete subclass of BlockClosure that supports selection
 blocks for associative access.' .
doc documentClassWith: txt.

txt := (GsDocText new) details:
'An ExecBlock.  The firstPC instance variable of this block refers to the
 first bytecode to execute to begin an associative access query, and the lastPC
 instance variable refers to the last bytecode of the associative access
 query.'.
doc documentInstVar: #queryBlock with: txt.

txt := (GsDocText new) details:
'An ExecBlock.  The firstPC instance variable of this block refers to the
 first bytecode to execute to begin execution of this block in GemStone 
 Smalltalk (no associative access), and the lastPC instance variable refers 
 to the last bytecode of the block''s GemStone Smalltalk execution.'.
doc documentInstVar: #iterationBlock with: txt.

self description: doc.
%

category: 'Accessing'
method: SelectBlock
queryBlock

"Returns the value of the queryBlock instance variable."

^queryBlock
%

category: 'Accessing'
method: SelectBlock
iterationBlock

"Returns the value of the iterationBlock instance variable."

^iterationBlock
%

category: 'Block Evaluation'
method: SelectBlock
value: anObject

"Returns the value of the receiver evaluated with anObject as its
 argument.  A SelectBlock can only take one argument."

^iterationBlock value: anObject
%
