!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: sessiontemps.gs 25988 2011-06-14 17:55:54Z stever $
!
! Superclass Hierarchy:
!    SessionTemps, SymbolDictionary, IdentityDictionary, IdentityKeyValueDictionary, 
!    KeyValueDictionary, AbstractDictionary, Collection, Object
!
!=========================================================================

expectvalue %String
run
| oldCls |
oldCls := Globals at:#SessionTemps otherwise: nil .
oldCls == nil ifTrue:[
  ^ SymbolDictionary _newKernelSubclass: #SessionTemps
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: #()
    inDictionary: Globals
    options: #( instancesNonPersistent  ) 
    reservedOop: nil
  ]
ifFalse:[
  ^ 'existing class: ' + oldCls definition
  ]
%

removeallmethods SessionTemps
removeallclassmethods SessionTemps

category: 'For Documentation Installation only'
classmethod: SessionTemps
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'Instances of SessionTemps may not be committed. The primary use of this class
 is via the class method #current, which returns an instance of SessionTemps
 that is stored in Transient Session State.' .
doc documentClassWith: txt.

self description: doc.
%

! ------------------- Class methods for SessionTemps
category: 'Session Temporaries'
classmethod: SessionTemps
current
^ (System _sessionStateAt: 1) ifNil:[ 
  System _sessionStateAt: 1 put: SessionTemps new .
  System _sessionStateAt: 1 
].
%
